<?php
/*
Plugin Name: Youtube Favorites Plugin/Widget
Version: 1.0
Plugin URI: http://frenchfragfactory.net/ozh/my-projects/wordpress-youtube-favorite-videos/
Description: Customizable display of your latest Youtube favorite videos. (<a href="../wp-content/plugins/youfave/wp_ozh_youfave.php">quick readme & manual</a>)
Author: Ozh
Author URI: http://planetozh.com/
*/

/* USER OPTIONS
 * Edit the following if you don't intend to use this plugin as a Widget 
 * If your theme is "Widget Enabled", then head to the admin interface,
 * found at Presentation / Sidebar Widgets of the Admin area.
 ****************************************************************************/

/* Your Youtube user name (login) */
$ozh_youfave['user'] = 'SomeDude666';

/* Your Youtube API Key. If you registered with Youtube, check this page and get yours :
   http://youtube.com/something		*/
$ozh_youfave['api'] = 'FaKEapIKey001';

/* How many favorite video you want to display */
$ozh_youfave['count'] = 3;

/* Display a little credit link to plugin below your favorites, so that your readers
 * can find about this plugin. Value is either 'yes' or 'no' */
$ozh_youfave['credit'] = 'yes';

/* How you want to display your favorite videos. Use any HTML with
 * a set of %%tokens%% listed below.
 * Write normal HTML and %%stuff%% enclosed in <<<TEMPLATE and TEMPLATE;
 * Warning : the closing TEMPLATE; must _*not*_ be indented ! (no tab or space before it)	*/
$ozh_youfave['template'] = <<<TEMPLATE
<p><a href="%%url%%" title="%%title%% : %%description%% (Tags: %%tags%%) (%%view_count%% views, rated %%rating_avg%%)"><img src="%%thumbnail_url%%" width="77" alt="%%title%% : %%description%% (Tags: %%tags%%) (%%view_count%% views, rated %%rating_avg%%)" /></a></p>
TEMPLATE;
/* Tokens you can use, and examples of value, are :
		%%author%% : somedude001
		%%id%% : kzGljuievpM
		%%title%% : A Funny Video
		%%length_seconds%% : 378
		%%length_minutes%% : 06'18''
		%%rating_avg%% : 4.24
		%%rating_count%% : 528
		%%description%% : Wow, what a cool video !
		%%upload_time%% : 1142348228
		%%upload_time_yours%% : 3/14/2006 2:57 pm (formatted with your own settings and time set, as defined in Options / General)
		%%comment_count%% : 199
		%%tags%% : funny humor wordpress
		%%url%% : http://www.youtube.com/?v=kzGljuievpM
		%%thumbnail_url%% : http://static17.youtube.com/vi/kzGljuievpM/2.jpg
		%%view_count%% : 157555
		%%view_count_pretty%% : 157,555
Example : "%%author%%" will be replaced with "somedude001"
*/


/* NO FURTHER EDITING
 * Or you're on your own. Note that even if you don't edit the following,
 * you're on your own as well :) But anyway, don't edit the following.
 ****************************************************************************/

// In case the API url changes :
$ozh_youfave['url'] = sprintf('http://www.youtube.com/api2_rest?method=youtube.users.list_favorite_videos&dev_id=%s&user=%s',$ozh_youfave['api'],$ozh_youfave['user']);
//$ozh_youfave['url']='http://127.0.0.1/youfav.xml';


/********** The core plugin part itself **********/


// Fetch the XML feed, either from cache or from fresh file
// The following function is based on those found in rss-functions.php to
// take full advantage of WP's built-in cache system
function ozh_youfave_fetch($url) {
	global $ozh_youfave;
	require_once(ABSPATH.'/wp-includes/rss-functions.php');
	
	init();
	$cache = new RSSCache( '', 3600 ); // use default or user-defined cache directory, and cache for one hour
	if (!$cache->ERROR) {
		// return cache HIT, MISS, or STALE
		$cache_status = $cache->check_cache($url);
	}
	
	// if object cached, and cache is fresh, return cached object
	if ( $cache_status == 'HIT' ) {
		$xml = $cache->get( $url );
		if ( isset($xml) and $xml ) {
			return $xml;
		}
	}

	$resp = _fetch_remote_file( $url, $request_headers );
	
	if (isset($resp) and $resp) {
		if ( ($resp->status == '304') ) {
			// We have the most current copy
			// I'm not even sure Youtube XML feeds can return a 304 header at the moment, but well, just in case.
			if ( MAGPIE_DEBUG > 1) {
				debug("Got 304 for $url");
			}
			// reset cache on 304
			$cache->set($url, $xml);
			return $xml;
		}
		elseif ( is_success( $resp->status ) ) {
			$xml = ( ozh_youfave_parsexml($resp->results) );
			if ( $xml ) {
				if (MAGPIE_DEBUG > 1) {
					debug("Fetch successful");
				}
				// add object to cache
				$cache->set( $url, $xml );
				return $xml;
			}
		}
		else {
			$errormsg = "Failed to fetch $url. ";
			if ( $resp->error ) {
				# compensate for Snoopy's annoying habbit to tacking
				# on '\n'
				$http_error = substr($resp->error, 0, -2); 
				$errormsg .= "(HTTP Error: $http_error)";
			}
			else {
				$errormsg .=  "(HTTP Response: " . $resp->response_code .')';
			}
		}
	}
	else {
		$errormsg = "Unable to retrieve RSS file for unknown reasons.";
	}
	
	// else fetch failed
	
	// Attempt to return cached object
	if ($xml) {
		if ( MAGPIE_DEBUG ) {
			debug("Returning STALE object for $url");
		}
		return $xml;
	}

	// This point reached ? I suggest panic :
	trigger_error($errormsg);	
}


// Parse raw XML data and return an array we can use
function ozh_youfave_parsexml($data) {
	require_once(dirname(__FILE__).'/xmlparser.php');
	$xml = new XMLParser($data,'raw');
	return(@$xml->getTree());
}


// Parse our "template" and print result
function ozh_youfave_print($data) {
	global $ozh_youfave;

	for($i=0;$i<min($ozh_youfave['count'],count($data['ut_response'][0]['video_list'][0]['video']));$i++) {
		foreach (array('author', 'id', 'title', 'view_count', 'length_seconds', 'rating_avg', 'rating_count', 'description', 'upload_time', 'comment_count', 'tags', 'url', 'thumbnail_url') as $item) {
			$items[$item] = $data['ut_response'][0]['video_list'][0]['video'][$i][$item][0]['VALUE'];
		}
		
		$items['upload_time_yours'] = date(get_settings('date_format'), $items['upload_time']) . ' ' . gmdate(get_settings('time_format'), $items['upload_time']);
		$items['length_minutes'] = ozh_youfave_secondstominutes($items['length_seconds']);
		$items['view_count_pretty'] = number_format($items['view_count'], 0, '', ',');
		
		$template = stripslashes($ozh_youfave['template']);
		foreach ($items as $k=>$v) {
			//print "		$k : $v<br/>\n";
			$template = str_replace("%%$k%%",$v,$template);
		}
		echo $template;
	}
	
	if ($ozh_youfave['credit'] == 'yes') {
		echo '<p style="font-size:8px;"><a href="http://frenchfragfactory.net/ozh/my-projects/wordpress-youtube-favorite-videos/" title="Youtube Favorites, a plugin for Wordpress">Youtube Favorites</a> by <a href="http://planetozh.com/">Ozh</a></p>';
	}
}


// Transform a number of seconds into hours:minutes:seconds
function ozh_youfave_secondstominutes($seconds) {
	$hours = floor($seconds / 3600);
	$min = floor(($seconds - ($hours * 3600)) / 60);
	if ($min < 10) $min = "0".$min;
	$sec = $seconds - ($hours * 3600) - ($min * 60);
	if ($sec < 10) $sec = "0".$sec;
	return $hours?$hours.":".$min."'".$sec."''":$min."'".$sec."''";
} 


// The main function you just need to use
function ozh_youfave() {
	global $ozh_youfave;

	if (function_exists('widget_ozh_youfave_checkoptions')) {
		$options = widget_ozh_youfave_checkoptions();
		$ozh_youfave = array_merge($ozh_youfave,$options);
	}
	
	ozh_youfave_print(ozh_youfave_fetch($ozh_youfave['url']));
	unset($ozh_youfave);
}


// Script called directly : print readme
if (!function_exists("get_settings")) {
	
	function ozh_youfave_readme() {

	echo <<<HTML
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Youtube Favorites Plugin / Widget for Wordpress &#8212; By Ozh</title>
<link rel="stylesheet" href="../../../wp-admin/wp-admin.css" type="text/css" />
<link rel="stylesheet" href="../../wp-admin/wp-admin.css" type="text/css" />
</head>

<body>
<div id="wphead" style="height: 4.5em">
<h1>Youtube Favorites Plugin / Widget &mdash; By Ozh</h1>
</div>
<div id="user_info"><p>Howdy, <strong>my friend</strong>.</p></div>

<ul id="adminmenu">

	<li><a class="current">Readme</a></li>

</ul>
<ul id="submenu">

	<li><a class="current">Youtube Favorites</a></li>
</ul>

	<div class="wrap">

	<h2>About</h2>
	<p>Thank you for installing this plugin / widget ! Ok, I'm not going to write "plugin / widget" all the way down. Let's call this... a <em>plugget</em> ! But first, what is supposed to be a <em>plugget</em> ?
	I call this a <em>plugget</em> because this script can either work as a standard <em>plugin</em>, or as a <em>widget</em> if you are using a widget enabled theme.</p>
	<p>The purpose of this plugget is to display, in a very customizable manner, your latest favorite videos from <a href="http://www.youtube.com/">Youtube</a></p>

	<p>&nbsp;</p>
	<h2>Installation &amp; Usage</h2>
	<p>Installation should be done already. By now, I guess you have unzipped 3 files (<code>wp_ozh_youfave.php</code>, <code>xmlparser.php</code> and <code>youtube_thumb.jpg</code>) in <code>wp-content/plugins/youfave/</code>, and activated this plugget in the Plugins admin page</p>
	<ul><li>If your theme <strong>is widget enabled</strong>, you have a "<a href="../../../wp-admin/themes.php?page=widgets/widgets.php">Sidebar Widgets</a>" submenu under the "Presentation" menu of the Admin area. You can customize everything from here, no need to get your hands dirty with messy PHP code editing !</li>
	<li>If your theme <strong>is not widget enabled</strong>, you'll have to edit manually the plugin to suit your needs. Don't worry, there's nothing complicated at all. It passed the Wife test successfully :P</li></ul>
	
	<p>&nbsp;</p>
	<h2>Customize</h2>
	<p>Either by manually editing the plugin or through the widget form, you will have to edit a few settings that are mostly self explanatory, except maybe the following :</p>
	<ul>
	<li><strong>Your Youtube API key</strong><br/>
	If you have a login, you have an API key already, it's a weird string like "K0olApIKay". Get it on <a href="http://youtube.com/my_profile_dev">this page</a>.</li>
	<li><strong>The template</strong><br/>
	You can customize the way you want your favorites to be displayed. To do so, enter any HTML and any of the following "template tags" detailed below with example values :
	
	<pre class="updated">
<code>%%id%%</code> : kzGljuievpM
<code>%%title%%</code> : A Funny Video
<code>%%length_seconds%%</code> : 378
<code>%%length_minutes%%</code> : 06'18''
<code>%%rating_avg%%</code> : 4.24
<code>%%rating_count%%</code> : 528
<code>%%description%%</code> : Awesome video !
<code>%%upload_time%%</code> : 1142348228
<code>%%upload_time_yours%%</code> : 3/14/2006 2:57 pm
<code>%%comment_count%%</code> : 199
<code>%%tags%%</code> : funny humor wordpress
<code>%%url%%</code> : http://www.youtube.com/?v=kzGljuievpM
<code>%%thumbnail_url%%</code> : http://static17.youtube.com/vi/kzGljuievpM/2.jpg
<code>%%view_count%%</code> : 2157555
<code>%%view_count_pretty%%</code> : 2,157,555
	</pre>
	The cool thing is that if you configure the plugin via the Widget form, there is a real time preview. How suparneat is that.
</li>
	</ul>

	<p>&nbsp;</p>
	<h2>Stuff</h2>
	<p>Have a clever question about this plugin ? Want to say thank you ? <a href="http://frenchfragfactory.net/ozh/my-projects/wordpress-youtube-favorite-videos/">Express yourself</a> !
	<p>If you like this plugin, I'll appreciate mucho muchly that you post a link to it in your blog, so that any of your readers that would like it too could get their hands on it. 
	If you <strong>love</strong> this plugin above all and if by some extraordinary coincidence you feel one dollar too rich, feel free to give this button the bad click frenzy it deserves :</p>
	<center><form action="https://www.paypal.com/cgi-bin/webscr" method="post"><input type="hidden" name="cmd" value="_xclick" /><input type="hidden" name="business" value="ozh@planetozh.com" /><input type="hidden" name="item_name" value="PlanetOzh Wordpress Plugins and Stuff" />
        <input type="hidden" name="return" value="http://frenchfragfactory.net/ozh/thankyou.php" />
        <input type="hidden" name="cancel_return" value="http://frenchfragfactory.net/ozh/my-projects/wordpress-youtube-favorite-videos/" />
        <input type="hidden" name="no_note" value="1" />
        <input type="hidden" name="currency_code" value="USD" />
        <input type="hidden" name="tax" value="0" />
        <input type="hidden" name="bn" value="PP-DonationsBF" />
        <input style="display:inline" type="image" src="https://www.paypal.com/en_US/i/btn/x-click-but04.gif" border="0" name="submit" alt="Donation via PayPal : fast, simple and secure !" />
	</form></center>
	<p>I have written several plugins for Wordpress, you will find them all on my <a href="http://frenchfragfactory.net/ozh/my-projects/">Projects</a> page.</p>
	</div>
	<div id="footer"><p><a href="http://planetOzh.com/"><img src="http://frenchfragfactory.net/ozh/wp-images/btn_planetozh.png" border="0" alt="planetOzh.com" /></a><br />
	</div>
	</body></html>
HTML;
}

ozh_youfave_readme();
exit;
}


/********** The optional widget part now **********/

function widget_ozh_youfave_init() {
	if ( !function_exists('register_sidebar_widget') )	return;

	global $ozh_youfave;


	function widget_ozh_youfave($args) {
		extract($args);
		$options = get_option('widget_ozh_youfave');
		$title = $options['title'];

		echo $before_widget . $before_title . $title . $after_title;
		ozh_youfave();
		echo $after_widget;
	}

	
	function widget_ozh_youfave_checkoptions() {
		global $ozh_youfave;
		$oldoptions = $options = get_option('widget_ozh_youfave');
		if (!$options['title']) $options['title'] = 'My Youtube Favorites';
		if (!$options['user']) $options['user'] = $ozh_youfave['user'];
		if (!$options['api']) $options['api'] = $ozh_youfave['api'];
		if (!$options['count']) $options['count'] = $ozh_youfave['count'];
		if (!$options['template']) $options['template'] = $ozh_youfave['template'];
		if (!$options['credit']) $options['credit'] = $ozh_youfave['credit'];
		
		if ($oldoptions != $options) update_option('widget_ozh_youfave', $options);
		
		return $options;
	}

	function widget_ozh_youfave_control() {
		global $ozh_youfave;
		// Get our options and see if we're handling a form submission.

		if ( $_POST['youfave-submit'] ) {
			$options['title'] = $_POST['youfave-title'];
			$options['user'] = $_POST['youfave-user'];
			$options['api'] = $_POST['youfave-api'];
			$options['count'] = $_POST['youfave-count'];
			$options['credit'] = $_POST['youfave-credit'];
			$options['template'] = $_POST['youfave-template'];
			update_option('widget_ozh_youfave', $options);
		}

		$options = widget_ozh_youfave_checkoptions();

		// A few formatting
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$user = htmlspecialchars($options['user'], ENT_QUOTES);
		$api = htmlspecialchars($options['api'], ENT_QUOTES);
		$count = htmlspecialchars($options['count'], ENT_QUOTES);
		$credit = htmlspecialchars($options['credit'], ENT_QUOTES);
		if ($credit =='yes') {$credityes = 'selected';$creditno = '';} else {$creditno = 'selected';$credityes = '';}
		$template = stripslashes(htmlspecialchars($options['template'], ENT_NOQUOTES));
		
		// Now the little form
		echo '<p>Display your latest Youtube favorites videos &mdash; by <a href="http://planetozh.com/">Ozh</a>.</p>';
		echo '<style>#ozhyoufave label,#ozhyoufave p{text-align:left;margin:0.1em}#ozhyoufave input{width:180px;}#ozhyoufave textarea {width:380px;height:100px;font-size:80%;}
		#ozhyoufave hr {clear:both;display:block;visibility:hidden;height:1em;}#ozhyoufave h3 {clear:both;margin-bottom:0.1em;}#ozhyoufave .ozhyoufavedisplayflip {float:right;font-size:80%;}
		#ozhyoufave #ozhyoufaverealtime {padding:0.6em;border:1px solid silver;background:#eef}#ozhyoufave #ozhyoufavequickref {font-size:90%;height:130px;overflow:auto;width:400px;}
		#ozhyoufave #ozhyoufavequickref .odd {background:#eee;}</style><div id="ozhyoufave">';
		echo '<script>function ozhyoufavepreview() {ozhyoufaveupdatepreview();$("ozhyoufavedisplay").style.display="none";$("ozhyoufavepreview").style.display="block";}
		function ozhyoufaveunpreview() {$("ozhyoufavedisplay").style.display="block";$("ozhyoufavepreview").style.display="none";$("ozhyoufavehelp").style.display="none";}
		function ozhyoufavehelp() {$("ozhyoufavedisplay").style.display="none";$("ozhyoufavepreview").style.display="none";$("ozhyoufavehelp").style.display="block";}
		function ozhyoufaveupdatepreview() {z=$("youfave-template");z=z.value;z=z.replace(/%%url%%/gi, "http://www.youtube.com/?v=QjA5faZF1A8");z=z.replace(/%%author%%/gi, "somedude001");z=z.replace(/%%id%%/gi, "fAkEvIDeoID");z=z.replace(/%%title%%/gi, "Guitar God");
		z=z.replace(/%%length_seconds%%/gi, "378");z=z.replace(/%%length_minutes%%/gi, "06\'18\'\'");z=z.replace(/%%rating_avg%%/gi, "4.24");z=z.replace(/%%rating_count%%/gi, "1528");
		z=z.replace(/%%description%%/gi, "Pretty cool video that is !");z=z.replace(/%%upload_time%%/gi, "1142348228");z=z.replace(/%%upload_time_yours%%/gi, "3/14/2006 2:57 pm");
		z=z.replace(/%%comment_count%%/gi, "199");z=z.replace(/%%tags%%/gi, "funny humor wordpress");z=z.replace(/%%thumbnail_url%%/gi, "http://127.0.0.1/wordpress/wp-content/plugins/youfave/youtube_thumb.jpg");
		z=z.replace(/%%view_count%%/gi, "157555");z=z.replace(/%%view_count_pretty%%/gi, "157,555");$("ozhyoufaverealtime").innerHTML = z;}</script>';
		echo '<h3>Settings</h3>';
		echo '<div style="float:left;width:190px;">';
		echo '<p><label for="youfave-title">Title:<br/><input id="youfave-title" name="youfave-title" type="text" value="'.$title.'" /></label></p>';
		echo '<p><label for="youfave-count">Number of Favorites:<br/><input id="youfave-count" name="youfave-count" type="text" value="'.$count.'" /></label></p>';
		echo '</div><div style="float:right;width:190px;">';
		echo '<p><label for="youfave-user">Youtube Login:<br/><input id="youfave-user" name="youfave-user" type="text" value="'.$user.'" /></label></p>';
		echo '<p><label for="youfave-api">Youtube API Key:<br/><input id="youfave-api" name="youfave-api" type="text" value="'.$api.'" /></label></p>';
		echo '</div><hr/>';
		echo '<p><label for="youfave-credit">Print small credit link to plugin <select id="youfave-credit" name="youfave-credit"><option value="yes" '.$credityes.'>Yes, sure</option><option value="no" '.$creditno.'>No thanks</option></select></label></p>';
		echo '<div id="ozhyoufavedisplay">';
		echo '<h3>Display</h3>';
		echo '<span class="ozhyoufavedisplayflip"><a href="javascript:ozhyoufavehelp()">? help</a> &#183; <a href="javascript:ozhyoufavepreview();">preview &rarr;</a></span><p><label for="youfave-template">Display Template:<br/><textarea id="youfave-template" name="youfave-template" rows="4" cols="60">'.$template.'</textarea></label></p>';
		echo '<input type="hidden" id="youfave-submit" name="youfave-submit" value="1" />';
		echo '<p>Empty fields will be reverted to their default values upon save. Still confused ? <a href="../wp-content/plugins/youfave/wp_ozh_youfave.php">RTFM</a> !</p>';
		echo '</div>';
		echo '<div id="ozhyoufavepreview" style="display:none">';
		echo '<h3>Preview</h3>';
		echo '<span class="ozhyoufavedisplayflip"><a href="javascript:ozhyoufaveunpreview();">&larr; back to template</a></span><p>Sample preview:</p>';
		echo '<div id="ozhyoufaverealtime"></div>';
		echo '<p>Keep in mind that the above preview could (will) be affected by your blog\'s main CSS.</p>';
		echo '</div>';
		echo '<div id="ozhyoufavehelp" style="display:none">';
		echo '<h3>Template Syntax</h3>';
		echo '<span class="ozhyoufavedisplayflip"><a href="javascript:ozhyoufaveunpreview();">&larr; back to template</a></span><p>Syntax quick reference</p>';
		echo '<div id="ozhyoufavequickref"><span class="odd"><code>%%author%%</code> : somedude001</span><br/><code>%%id%%</code> : kzGljuievpM<br/><span class="odd"><code>%%title%%</code> : Guitar God</span><br/>
		<code>%%length_seconds%%</code> : 378<br/><span class="odd"><code>%%length_minutes%%</code> : 06\'18\'\'</span><br/><code>%%rating_avg%%</code> : 4.24<br/><span class="odd"><code>%%rating_count%%</code> : 528</span><br/>
		<code>%%description%%</code> : Awesome video !<br/><span class="odd"><code>%%upload_time%%</code> : 1142348228</span><br/><code>%%upload_time_yours%%</code> : 3/14/2006 2:57 pm<br/>
		<span class="odd"><code>%%comment_count%%</code> : 199</span><br/><code>%%tags%%</code> : funny humor wordpress<br/><span class="odd"><code>%%url%%</code> : http://www.youtube.com/?v=kzGljuievpM</span><br/>
		<code>%%thumbnail_url%%</code> : http://img.youtube.com/kzGl/2.jpg<br/><span class="odd"><code>%%view_count%%</code> : 157555</span><br/><code>%%view_count_pretty%%</code> : 157,555<br/></div>';
		echo '</div>';
		echo '</div>';
	}
	
	// Register the widget so it can be used and dragged and dropped into any active sidebars
	register_sidebar_widget('Youtube Favorites', 'widget_ozh_youfave');

	// Register the widget control form
	register_widget_control('Youtube Favorites', 'widget_ozh_youfave_control', 400, 430);
}

// Run our code later in case this loads prior to any required plugins.
add_action('plugins_loaded', 'widget_ozh_youfave_init');
?>